.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include DlgMain.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM



	.if uMsg==WM_INITDIALOG

	invoke GetDlgItem,hWnd,IDC_LIST
	   mov hList,eax
	invoke InsertColumns
	invoke AddItem,addr szText
	invoke AddItem,addr szText
	invoke AddItem,addr szText

          .elseif uMsg == WM_NOTIFY

         push edi
         mov edi,lParam
         assume edi:ptr NMHDR
         mov eax,[edi].hwndFrom
         .if eax==hList
           .if [edi].code == NM_CUSTOMDRAW
               mov ecx,edi
               ASSUME ecx:ptr NMLVCUSTOMDRAW
               .if [ecx].nmcd.dwDrawStage == CDDS_PREPAINT
                  mov eax,CDRF_NOTIFYITEMDRAW
                  ret
               .elseif [ecx].nmcd.dwDrawStage == CDDS_ITEMPREPAINT
                  mov eax, [ecx].nmcd.dwItemSpec
                  and eax, 1
                  dec eax
                  and eax, (00C5C5C5h - 00D6D8D3h)
                  add eax, 00787878h
                  mov [ecx].clrTextBk, eax
                  mov eax, CDRF_NEWFONT
                  ret
                  ASSUME ecx:nothing
               .endif
            .endif
          .endif
          pop edi
	.elseif uMsg==WM_COMMAND

     
	.elseif uMsg==WM_CLOSE
	
		invoke EndDialog,hWnd,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

InsertColumns proc
LOCAL lvc:LV_COLUMN
    invoke SendMessage,hList,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT or LVS_EX_FLATSB ,-1
	mov lvc.imask,LVCF_TEXT+LVCF_WIDTH
	mov lvc.pszText,0
	mov lvc.lx,200
	invoke SendMessage,hList, LVM_INSERTCOLUMN,0,addr lvc
ret
InsertColumns endp


AddItem PROC lpszText:DWORD
LOCAL lvi:LV_ITEM
    invoke lstrcpy,addr hText,lpszText
    mov	lvi.imask,LVIF_TEXT
    mov	lvi.pszText,offset hText
    mov	lvi.iSubItem,0
    invoke	SendMessage,hList,LVM_INSERTITEM,0,addr lvi
ret   
AddItem ENDP

end start
